unit Main;

interface

uses WinTypes, WinProcs, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, About;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Panel1: TPanel;
    StatusLine: TPanel;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    Panel2: TPanel;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    SpeedPanel: TPanel;
    BtnOpen: TSpeedButton;
    BtnSave: TSpeedButton;
    BtnCut: TSpeedButton;
    BtnCopy: TSpeedButton;
    BtnPaste: TSpeedButton;
    BtnExit: TSpeedButton;
    EditUndoItem: TMenuItem;
    EditDeleteItem: TMenuItem;
    EditSelectAllItem: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    FileInsertItem: TMenuItem;
    N4: TMenuItem;
    FileInfoItem: TMenuItem;
    N5: TMenuItem;
    FilePrintItem: TMenuItem;
    FilePrintSetupItem: TMenuItem;
    BtnDelete: TSpeedButton;
    BtnUndo: TSpeedButton;
    WindowNewItem: TMenuItem;
    WindowPreviewItem: TMenuItem;
    WindowHeadersFootersItem: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Misc1: TMenuItem;
    MiscInsertTableItem: TMenuItem;
    MiscInsertPictureItem: TMenuItem;
    BtnInsertTable: TSpeedButton;
    BtnPrint: TSpeedButton;
    BtnInsertPicture: TSpeedButton;
    Font1: TMenuItem;
    FontStandardItem: TMenuItem;
    FontBoldItem: TMenuItem;
    FontItalicItem: TMenuItem;
    FontUnderlineItem: TMenuItem;
    FontStrikeoutItem: TMenuItem;
    N9: TMenuItem;
    FontSubscriptItem: TMenuItem;
    FontSuperscriptItem: TMenuItem;
    N10: TMenuItem;
    FontChooseColorItem: TMenuItem;
    FontChooseFontItem: TMenuItem;
    Search1: TMenuItem;
    SearchFindItem: TMenuItem;
    SearchReplaceItem: TMenuItem;
    N11: TMenuItem;
    SearchContinueSearchItem: TMenuItem;
    BtnNew: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure FileOpenItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure EditCutItemClick(Sender: TObject);
    procedure EditCopyItemClick(Sender: TObject);
    procedure EditPasteItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnCutClick(Sender: TObject);
    procedure BtnCopyClick(Sender: TObject);
    procedure BtnPasteClick(Sender: TObject);
    procedure EditUndoItemClick(Sender: TObject);
    procedure EditSelectAllItemClick(Sender: TObject);
    procedure EditDeleteItemClick(Sender: TObject);
    procedure FileInsertItemClick(Sender: TObject);
    procedure FilePrintItemClick(Sender: TObject);
    procedure FilePrintSetupItemClick(Sender: TObject);
    procedure FileInfoItemClick(Sender: TObject);
    procedure BtnDeleteClick(Sender: TObject);
    procedure BtnUndoClick(Sender: TObject);
    procedure WindowNewItemClick(Sender: TObject);
    procedure WindowPreviewItemClick(Sender: TObject);
    procedure WindowHeadersFootersItemClick(Sender: TObject);
    procedure MiscInsertTableItemClick(Sender: TObject);
    procedure MiscInsertPictureItemClick(Sender: TObject);
    procedure BtnInsertTableClick(Sender: TObject);
    procedure BtnPrintClick(Sender: TObject);
    procedure BtnInsertPictureClick(Sender: TObject);
    procedure FontStandardItemClick(Sender: TObject);
    procedure FontBoldItemClick(Sender: TObject);
    procedure FontItalicItemClick(Sender: TObject);
    procedure FontUnderlineItemClick(Sender: TObject);
    procedure FontStrikeoutItemClick(Sender: TObject);
    procedure FontSuperscriptItemClick(Sender: TObject);
    procedure FontSubscriptItemClick(Sender: TObject);
    procedure FontChooseFontItemClick(Sender: TObject);
    procedure FontChooseColorItemClick(Sender: TObject);
    procedure SearchContinueSearchItemClick(Sender: TObject);
    procedure SearchFindItemClick(Sender: TObject);
    procedure SearchReplaceItemClick(Sender: TObject);
    procedure BtnNewClick(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
  private
    { Private declarations }
    procedure CreateMDIChild(const Name: string);
    procedure ShowHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
  Screen.OnActiveFormChange := UpdateMenuItems;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.Caption := Application.Hint;
end;

procedure TMainForm.CreateMDIChild(const Name: string);
var
  Child: TMDIChild;
begin
  { create a new MDI child window }
  Child := TMDIChild.Create(Application);
  Child.Caption := Name;
end;

procedure TMainForm.FileNewItemClick(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.FileOpenItemClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    CreateMDIChild(OpenDialog.FileName);
    (ActiveMDIChild as TMDIChild).HighEdit1.FileName := OpenDialog.FileName;
  end;
end;

procedure TMainForm.FileCloseItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.FileExit;
end;

procedure TMainForm.FileSaveItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.FileSave;
end;

procedure TMainForm.FileSaveAsItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.FileSaveAs;
end;

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditCutItemClick(Sender: TObject);
begin
  EditCutItemClick(Sender);
end;

procedure TMainForm.EditCopyItemClick(Sender: TObject);
begin
  EditCopyItemClick(Sender);
end;

procedure TMainForm.EditPasteItemClick(Sender: TObject);
begin
  EditPasteItemClick(Sender);
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure TMainForm.UpdateMenuItems(Sender: TObject);
begin
  Edit1.Visible := MDIChildCount > 0;
  Font1.Visible := MDIChildCount > 0;
  Search1.Visible := MDIChildCount > 0;
  Misc1.Visible := MDIChildCount > 0;
  Window1.Visible := MDIChildCount > 0;

  FileInsertItem.Enabled := MDIChildCount > 0;
  FileSaveItem.Enabled := MDIChildCount > 0;
  FileSaveAsItem.Enabled := MDIChildCount > 0;
  FileInfoItem.Enabled := MDIChildCount > 0;
  FilePrintItem.Enabled := MDIChildCount > 0;

  {
  EditUndoItem.Enabled := MDIChildCount > 0;
  EditCutItem.Enabled := MDIChildCount > 0;
  EditCopyItem.Enabled := MDIChildCount > 0;
  EditPasteItem.Enabled := MDIChildCount > 0;
  EditDeleteItem.Enabled := MDIChildCount > 0;
  EditSelectAllItem.Enabled := MDIChildCount > 0;

  FontStandardItem.Enabled := MDIChildCount > 0;
  FontBoldItem.Enabled := MDIChildCount > 0;
  FontItalicItem.Enabled := MDIChildCount > 0;
  FontUnderlineItem.Enabled := MDIChildCount > 0;
  FontStrikeoutItem.Enabled := MDIChildCount > 0;
  FontSuperscriptItem.Enabled := MDIChildCount > 0;
  FontSubscriptItem.Enabled := MDIChildCount > 0;
  FontChooseColorItem.Enabled := MDIChildCount > 0;
  FontChooseFontItem.Enabled := MDIChildCount > 0;

  SearchFindItem.Enabled := MDIChildCount > 0;
  SearchReplaceItem.Enabled := MDIChildCount > 0;
  SearchContinueSearchItem.Enabled := MDIChildCount > 0;

  MiscInsertPictureItem.Enabled := MDIChildCount > 0;
  MiscInsertTableItem.Enabled := MDIChildCount > 0;

  WindowHeadersFootersItem.Enabled := MDIChildCount > 0;
  WindowPreviewItem.Enabled := MDIChildCount > 0;
  WindowCascadeItem.Enabled := MDIChildCount > 0;
  WindowTileItem.Enabled := MDIChildCount > 0;
  WindowArrangeItem.Enabled := MDIChildCount > 0;
  WindowMinimizeItem.Enabled := MDIChildCount > 0;
  }

  BtnPrint.Enabled := MDIChildCount > 0;
  BtnSave.Enabled := MDIChildCount > 0;
  BtnCut.Enabled := MDIChildCount > 0;
  BtnCopy.Enabled := MDIChildCount > 0;
  BtnPaste.Enabled := MDIChildCount > 0;
  BtnDelete.Enabled := MDIChildCount > 0;
  BtnUndo.Enabled := MDIChildCount > 0;
  BtnInsertTable.Enabled := MDIChildCount > 0;
  BtnInsertPicture.Enabled := MDIChildCount > 0;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange := nil;
end;

procedure TMainForm.BtnCutClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.EditCut;
end;

procedure TMainForm.BtnCopyClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.EditCopy;
end;

procedure TMainForm.BtnPasteClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.EditPaste;
end;

procedure TMainForm.EditUndoItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.EditUndo;
end;

procedure TMainForm.EditSelectAllItemClick(Sender: TObject);
begin
   if ActiveMDIChild <> nil then
     (ActiveMDIChild as TMDIChild).HighEdit1.EditSelect;
end;

procedure TMainForm.EditDeleteItemClick(Sender: TObject);
begin
   if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.EditClear;
end;

procedure TMainForm.FileInsertItemClick(Sender: TObject);
begin
   if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.FileInsert;
end;

procedure TMainForm.FilePrintItemClick(Sender: TObject);
begin
   if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.FilePrint;
end;

procedure TMainForm.FilePrintSetupItemClick(Sender: TObject);
begin
   if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.FilePrintSetup;
end;

procedure TMainForm.FileInfoItemClick(Sender: TObject);
begin
   if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.FileInfo;
end;

procedure TMainForm.BtnDeleteClick(Sender: TObject);
begin
  EditDeleteItemClick(Sender);
end;

procedure TMainForm.BtnUndoClick(Sender: TObject);
begin
  EditUndoItemClick(Sender);
end;

procedure TMainForm.WindowNewItemClick(Sender: TObject);
begin
  CreateMDIChild('NONAME' + IntToStr(MDIChildCount + 1));
end;

procedure TMainForm.WindowPreviewItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Preview;
end;

procedure TMainForm.WindowHeadersFootersItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.HeadFoot;
end;

procedure TMainForm.MiscInsertTableItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.InsertTable;
end;

procedure TMainForm.MiscInsertPictureItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.InsertPicture;
end;

procedure TMainForm.BtnInsertTableClick(Sender: TObject);
begin
  MiscInsertTableItemClick(Sender);
end;

procedure TMainForm.BtnPrintClick(Sender: TObject);
begin
  FilePrintItemClick(Sender);
end;

procedure TMainForm.BtnInsertPictureClick(Sender: TObject);
begin
  MiscInsertPictureItemClick(Sender);
end;

procedure TMainForm.FontStandardItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Standard;
end;

procedure TMainForm.FontBoldItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Bold;
end;

procedure TMainForm.FontItalicItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Italic;
end;

procedure TMainForm.FontUnderlineItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Underline;
end;

procedure TMainForm.FontStrikeoutItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.StrikeOut;
end;

procedure TMainForm.FontSuperscriptItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.SuperScript;
end;

procedure TMainForm.FontSubscriptItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.SubScript;
end;

procedure TMainForm.FontChooseFontItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.NewFont;
end;

procedure TMainForm.FontChooseColorItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Color;
end;

procedure TMainForm.SearchContinueSearchItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.SearchCont;
end;

procedure TMainForm.SearchFindItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Find;
end;

procedure TMainForm.SearchReplaceItemClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    (ActiveMDIChild as TMDIChild).HighEdit1.Replace;
end;

procedure TMainForm.BtnNewClick(Sender: TObject);
begin
  FileNewItemClick(Sender);
end;

procedure TMainForm.HelpAboutItemClick(Sender: TObject);
begin
  AboutBox := TAboutBox.Create(Application);
  AboutBox.ShowModal;
end;

end.
