{*******************************************************************}
{								    }
{	HEReg Unit. Enthlt die Register-Routine zum einbinden      }
{       der HighEdit Komponenten in die Complib, sowie einen        }
{       Property Editor zum Laden von HighEdit-Texten zur           }
{       Designzeit.                                                 }
{	Name:  HEReg.pas 					    }
{	Autor: Jan Hamann                                           }
{	Datum: 5.4.94						    }
{								    }
{*******************************************************************}

unit HeReg;

interface

uses SysUtils, Classes, Graphics, Controls, Forms, DsgnIntf;

type
  THEFilenameProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;

{======================================================================}

implementation

uses WinTypes, WinProcs, Menus, Dialogs, HEComp, HeCompDB;

const
  SHEOpenFilter = 'HighEdit (*.hed)|*.hed|ANSI (*.txt)|*.txt|OEM (*.txt)|*.txt|' +
                  'Rich Text Format (*.rtf)|*.rtf|Alle Dateien (*.*)|*.*';

{======================================================================}

{ TFilenameProperty }

procedure THEFilenameProperty.Edit;
var
  FileOpen: TOpenDialog;
begin
  FileOpen := TOpenDialog.Create(Application);
  FileOpen.Filename := GetValue;
  FileOpen.Filter := SHEOpenFilter;
  try
    if FileOpen.Execute then SetValue(FileOpen.Filename);
  finally
    FileOpen.Free;
  end;
end;

function THEFilenameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{======================================================================}

procedure Register;
begin
  RegisterComponents('Heiler Software', [THighEdit, TDBHighEdit]);
  RegisterPropertyEditor(TypeInfo(TFileName), THighEdit, 'FileName', THEFileNameProperty);
end;

{======================================================================}
end.
