{*******************************************************************}
{																	}
{	HighEdit Unit zum Einbinden in das jeweilige Hauptprogramm	    }
{																	}
{	Name:  highedit.pas 											}
{	Autor: Andreas Claus											}
{	Datum: 5.1.94													}
{																	}
{*******************************************************************}

unit HighEdit;

{$S-}

interface

uses WinTypes, WinProcs, Messages;

{ HIGHEDIT.DLL }

const
	hs_Dialog				= $0000000010;
	hs_ExternSwappper		= $0000000020;
	hs_AutoHSize			= $0000000040;
	hs_Profile				= $0000000080;
	hs_Notify				= $0000000100;
    hs_Undo					= $0000000200;
	hs_HeadFoot 			= $0000000800;

	ws_DefHighEdit			= ws_Child + ws_Visible + ws_ClipChildren + hs_Profile;

	class_HighEdit			= 'HighEdit';

	context_Main			= 0;
	context_Head			= 1;
	context_Foot			= 2;

	of_Append				= 4;
	of_DefHESave			= of_Create + of_ReadWrite + of_Share_Deny_None;

	print_Text				= 0;
  	print_End				= 0;
	print_Start 			= 1;
	print_FullDocument		= 4;
	print_InsertDocument	= 5;
	print_FullDocumentAbortDlg = 7;

	fragment_None			= -1;
	fragment_Text			= 0;
	fragment_Formfeed		= 1;
	fragment_Linefeed		= 2;
	fragment_Tab			= 3;
	fragment_Bitmap 		= 4;
	fragment_PF 			= 6;
	fragment_BmpScale		= 8;
	fragment_MetaFile		= 9;
	fragment_BmpKeepRatio	= 10;
	fragment_MFScale		= 11;
	fragment_MFKeepRatio	= 12;

	attr_Standart			= 0;
	attr_Bold				= 1;
	attr_Underline			= 2;
	attr_Italic 			= 4;
	attr_StrikeOut			= 8;
	attr_SubScript			= 16;
	attr_SuperScript		= 32;

	current_Attribute		= 255;

	font_Typ				= $0F;

	font_Display			= $00;
	font_Printer			= $01;
	font_Logical			= $02;

	font_Set				= $F0;

	font_Set_None			= $00;
	font_Set_Style			= $10;
	font_Set_Color			= $20;
	font_Set_Name			= $40;
	font_Set_Size			= $80;

	font_Set_All			= font_Set_Style + font_Set_Color + font_Set_Name + font_Set_Size;

	tab_Left				= 0;
	tab_Right				= 1;
	tab_Decimal 			= 2;
	tab_Center				= 3;
	tab_LeftMargin			= 6;
	tab_RightMargin 		= 7;
	tab_Indent				= 9;

	typ_Text				= 0;
	typ_Bitmap				= 6;
	typ_User				= 10;

	rgb_Black				= $00000000;
	rgb_Blue				= $00FF0000;
	rgb_Cyan				= $00FFFF00;
	rgb_Green				= $0000FF00;
	rgb_Magenta 			= $00FF00FF;
	rgb_Red 				= $000000FF;
	rgb_Yellow				= $0000FFFF;
	rgb_White				= $00FFFFFF;

	rgb_DkBlue				= $007F0000;
	rgb_DkCyan				= $007F7F00;
	rgb_DkGreen 			= $00007F00;
	rgb_DkMagenta			= $007F007F;
	rgb_DkRed				= $0000007F;
	rgb_DkYellow			= $00007F7F;

	rgb_Gray				= $007F7F7F;
	rgb_LtGray				= $00C0C0C0;

	current_Color			= $FFFFFFFF;

	align_Mask				= 3;
	align_Left				= 0;
	align_Right 			= 1;
	align_Center			= 2;
	align_Justify			= 3;

	line_Visible			= 4;
	line_SoftReturn 		= 8;
	line_HardReturn 		= 16;
	line_Formfeed			= 32;
	line_Tabulator			= 128;
	line_InvisiblePF		= 1024;
	line_PaginateFF 		= 2048;
	line_NotEditable		= 4096;

	spacing_Mask			= 768;
	spacing_One 			= 0;
	spacing_OneHalf 		= 1;
	spacing_Double			= 2;

	status_Info 			= 0;
	status_X				= 1;
	status_Y				= 2;
	status_Page 			= 3;
	status_Element_Count	= 4;

	search_Forward			= 0;
	search_Case 			= 2;
	search_Word 			= 4;
	search_Cursor			= 8;
	search_Back 			= 16;
	search_Init 			= 32;

	search_NotFound 		= 0;
	search_Found			= 1;
	search_Error			= 2;

	nextpf_Backward 		= 0;
	nextpf_Forward			= 1;
	nextpf_OnlyEditable 	= 2;
	nextpf_OnlyVisible		= 16;
	nextpf_FileEndStop		= 32;

	pf_AlignMask			= 3;

	pf_AlignLeft			= 0;
	pf_AlignRight			= 1;

	pf_Editable 			= 4;
	pf_Function 			= 8;
	pf_Visible				= 32;
	pf_LineRemove			= 64;
	pf_FixedSize			= 128;
	pf_Multiline			= 256;

    bmp_Error				= $80008000;
    bmp_None				= -1;
    bmp_Original			= 0;
    bmp_Scale				= 1;
    bmp_KeepRatio			= 2;

	docinfo_Title			= 0;
	docinfo_Subject 		= 1;
	docinfo_Operator		= 2;
	docinfo_Author			= 3;
	docinfo_Kekwords		= 4;
	docinfo_Comment 		= 5;

	docinfo_CreateTime		= 6;
	docinfo_RevisionTime	= 7;
	docinfo_PrintTime		= 8;

	docinfo_FirstTime		= 6;
	docinfo_LastTime		= 8;

	unit_CM 				= 2540;
	unit_IN 				= 1000;

    table_AdjustColumns		= 1;
    table_AdjustRows		= 2;
    table_AdjustRedraw		= 4;

	hef_LowMemory			=	1;
	hef_NoBlockMark 		=	2;
	hef_NoHEFile			=	3;
	hef_NoLoad				=	4;
	hef_NoMemory			=	5;
	hef_NoSave				=	6;
	hef_NoStart 			=	7;
	hef_NoTmpClose			=	8;
	hef_NoTmpOpen			=	9;
	hef_NoTmpSpace			=	10;
	hef_NoRTFFile			=	11;
	hef_WrongVersion		=	12;
	hef_NoFont				=	13;
	hef_NoPrinter			=	14;
	hef_NoWriteAccess		=	15;
	hef_LowResources		=	16;

	hem_Align				=	20;
	hem_Click				=	21;
	hem_DblClk				=	22;
	hem_EndPF				=	24;
	hem_FormatPF			=	25;
	hem_GetHScrollPos		=	26;
	hem_GetVScrollPos		=	27;
	hem_HScroll 			=	28;
	hem_Insert				=	29;
	hem_KillFocus			=	30;
	hem_ModifyPF			=	32;
	hem_SelectPF			=	34;
	hem_SetFocus			=	35;
	hem_SetHScrollPos		=	36;
	hem_SetHScrollRange 	=	37;
	hem_SetVScrollRange 	=	39;
	hem_SetVScrollPos		=	40;
	hem_SizePF				=	41;
	hem_Spacing 			=	42;
	hem_Style				=	43;
	hem_TabModify			=	44;
	hem_VScroll 			=	46;
	hem_PrintHead			=	47;
	hem_PrintFoot			=	48;
	hem_CursorPos			=	49;
	hem_MessageText 		=	50;
	hem_FileExists			=	52;
	hem_NewPageFragment 	=	57;
	hem_Font				=	60;
	hem_FontSize			=	61;
	hem_InitNew 			=	62;
	hem_InsertPF			=	86;
	hem_SelectPicture		=	89;
	hem_TabWidth			=	90;

    hem_QueryProfileName	= 	93;

	he_AppendANSI				= wm_User + 20;
	he_AppendDATA				= wm_User + 21;
	he_AppendOEM				= wm_User + 22;

	he_ChangeFunctionPF 		= wm_User + 41;
	he_CursorEnd				= wm_User + 45;
	he_CursorHome				= wm_User + 46;
	he_CountToken				= wm_User + 47;

	he_DeletePF 				= wm_User + 50;
	he_DeleteTab				= wm_User + 51;

	he_FmtLines 				= wm_User + 60;
	he_Format					= wm_User + 61;
	he_Formfeed 				= wm_User + 62;

	he_GetAlign 				= wm_User + 70;
	he_GetChar					= wm_User + 71;
	he_GetColor 				= wm_User + 72;
	he_GetCursor				= wm_User + 73;
	he_GetFontHandle			= wm_User + 74;
	he_IsInsertMode 			= wm_User + 75;

    { Alter Name aus Kompatibilittsgrnden vorhanden }
	he_GetInsert				= he_IsInsertMode;

	he_GetLine					= wm_User + 77;
	he_GetLineCount 			= wm_User + 78;

	he_GetPFData				= wm_User + 79;
	he_GetPFFlags				= wm_User + 80;
	he_GetStyle 				= wm_User + 81;
	he_GetTyp					= wm_User + 82;
	he_GetHeadRect				= wm_User + 83;
	he_GetFootRect				= wm_User + 84;

	he_GetNotifyTabList 		= wm_User + 85;
	he_GetNotifyProtectHandle	= wm_User + 88;
	he_GetNotifyProtectWidth	= wm_User + 90;
	he_GetNotifyScrollHeight	= wm_User + 91;
	he_GetNotifyScrollWidth 	= wm_User + 92;
	he_GetNotifyHScrollRange	= wm_User + 93;
	he_GetNotifyHScrollPos		= wm_User + 94;
	he_GetNotifyVScrollRange	= wm_User + 95;
	he_GetNotifyVScrollPos		= wm_User + 96;
	he_GetNotifyMessageText 	= wm_User + 97;
	he_GetNotifyMessageLen		= wm_User + 98;

	he_GetPrinterDC 			= wm_User + 99;
	he_GetPage					= wm_User + 100;
	he_GetPFDataLen 			= wm_User + 101;
	he_GetSelection 			= wm_User + 102;
	he_GetSpacing				= wm_User + 103;
	he_GetString				= wm_User + 104;
	he_GetFragment				= wm_User + 105;
	he_GetPrinterTextHeight 	= wm_User + 106;
	he_GetTextSel				= wm_User + 107;
	he_GetTextWidth 			= wm_User + 108;

	he_InsertFunctionPF 		= wm_User + 114;
	he_InsertTab				= wm_User + 117;

	he_LineLength				= wm_User + 130;
	he_LoadANSI 				= wm_User + 131;
	he_LoadDATA 				= wm_User + 132;
	he_LoadOEM					= wm_User + 133;
	he_LockFunctionPF			= wm_User + 135;

	he_IsModified				= wm_User + 140;

	{ Alter Name aus Kompatibilittsgrnden vorhanden }
	he_Modify					= he_IsModified;

	he_MoveTab					= wm_User + 141;
	he_MoveMargin				= wm_User + 142;

	he_New						= wm_User + 150;
	he_NextPF					= wm_User + 151;

	he_PrintDocument			= wm_User + 161;
	he_PrintFragment			= wm_User + 162;

	he_QuickReplace 			= wm_User + 170;

	he_ReplaceSel				= wm_User + 184;

	he_SaveANSI 				= wm_User + 190;
	he_SaveDATA 				= wm_User + 191;
	he_SaveOEM					= wm_User + 192;
	he_Search					= wm_User + 194;
	he_SelectAll				= wm_User + 195;
	he_SelectWord				= wm_User + 197;
	he_SetAlign 				= wm_User + 198;
	he_SetAllPFFlags			= wm_User + 199;
	he_SetAutoHSize 			= wm_User + 200;
	he_SetCursor				= wm_User + 201;
	he_SetCRVisible 			= wm_User + 202;
	he_SetFont					= wm_User + 203;
	he_SetGrayBk				= wm_User + 204;
	he_SetInsert				= wm_User + 206;
	he_SetLeftMargin			= wm_User + 207;
	he_SetLineBreak 			= wm_User + 209;
	he_SetSpacing				= wm_User + 210;
	he_SetMouseCursor			= wm_User + 212;
	he_SetOffset				= wm_User + 213;
	he_SetPFBkVisible			= wm_User + 214;
	he_SetPFFunctionVisible 	= wm_User + 215;
	he_SetPFFlags				= wm_User + 216;
	he_SetScrollPos 			= wm_User + 217;
	he_SetSelection 			= wm_User + 218;
	he_SetSpaceVisible			= wm_User + 219;
	he_SetStyle 				= wm_User + 220;
	he_SetTab					= wm_User + 221;
	he_SetTabVisible			= wm_User + 222;
	he_SetTabWidth				= wm_User + 223;
	he_SetTextHeight			= wm_User + 224;
	he_SetTextWidth 			= wm_User + 225;
	he_SetTopMargin 			= wm_User + 226;
	he_SetHScroll				= wm_User + 227;
	he_SetVScroll				= wm_User + 228;
	he_StatusLine				= wm_User + 229;

	he_UnlockFunctionPF 		= wm_User + 240;

	he_GetTabWidth				= wm_User + 246;
	he_SetMargins				= wm_User + 247;
	he_GetMargins				= wm_User + 248;
	he_GetPhysicalDim			= wm_User + 249;
	he_SetTextDim				= wm_User + 250;
	he_GetTextDim				= wm_User + 251;
	he_CopyData 				= wm_User + 253;
	he_PasteData				= wm_User + 254;
	he_CanCopy					= wm_User + 256;
	he_CanPaste 				= wm_User + 257;
	he_GetPhysicalMargins		= wm_User + 258;
	he_GetPrinterDim			= wm_User + 259;
	he_LoadRTF					= wm_User + 263;
	he_AppendRTF				= wm_User + 264;
	he_SaveRTF					= wm_User + 265;
	he_WriteProfile 			= wm_User + 266;
	he_IsPFActive				= wm_User + 267;
	he_CloseActivePF			= wm_User + 268;
	he_SetPFGhost				= wm_User + 269;
	he_SetModified				= wm_User + 270;

	{ ab Version 1.04h }

	he_SetLineGhost 			= wm_User + 271;
	he_AddPFFlags				= wm_User + 272;
	he_ClearPFFlags 			= wm_User + 273;
	he_AddAllPFFlags			= wm_User + 274;
	he_ClearAllPFFlags			= wm_User + 275;
	he_ExtSetRedraw 			= wm_User + 277;
	he_GetPrinterIC 			= wm_User + 278;

	{ ab Version 1.05 }

	he_Paginate 				= wm_User + 279;
	he_IsLineBreak				= wm_User + 280;
	he_IsGrayBk 				= wm_User + 281;
	he_IsPFBkVisible			= wm_User + 282;
	he_IsTabVisible 			= wm_User + 283;
	he_IsCRVisible				= wm_User + 284;
	he_IsSpaceVisible			= wm_User + 285;
	he_IsPFFunctionVisible		= wm_User + 286;
	he_IsPFGhost				= wm_User + 287;
	he_IsLineGhost				= wm_User + 288;
	he_GetNotifyNewPageFragment = wm_User + 289;
	he_GetNotifyProtectLen		= wm_User + 290;

	{ ab Version 1.10 }

	he_GetDocInfo				= wm_User + 294;
	he_SetDocInfo				= wm_User + 295;
	he_GetColorLogFont			= wm_User + 296;
	he_GetFontIndex 			= wm_User + 297;
	he_SetColorLogFont			= wm_User + 298;
	he_GetRGB					= wm_User + 299;
	he_AddFunctionPF			= wm_User + 300;

    he_SetUnit					= wm_User + 302;
    he_GetUnit					= wm_User + 303;
    he_SetReadOnly				= wm_User + 305;
    he_IsReadOnly				= wm_User + 306;

   	{ ab Version 1.12b }

    he_GetNotifyResources		= wm_User + 321;

    { ab Version 1.13 }

	he_IsFormfeed			    = wm_User + 310;
	he_InsertFunctionPFParam    = wm_User + 323;
	he_NextPFExt                = wm_User + 324;
	he_SetAllPFFlagsExt         = wm_User + 325;
	he_AddAllPFFlagsExt         = wm_User + 326;
	he_ClearAllPFFlagsExt       = wm_User + 327;
	he_SetPFBkColor             = wm_User + 331;
	he_GetPFBkColor             = wm_User + 332;
	he_GetPrinterLineHeight     = wm_User + 333;
	he_GetPrinterCursorHeight   = wm_User + 334;
	he_GetEOFChar               = wm_User + 335;
    he_SetEOFChar				= wm_User + 336;

    { ab Version 1.13b }

	he_GetSelectionStart        = wm_User + 338;

    { ab Version 1.14 }

	he_SetRBMargins             = wm_User + 340;
	he_GetRBMargins             = wm_User + 341;
	he_GetPFWidth               = wm_User + 342;
	he_SetPFWidth               = wm_User + 343;
	he_SetAllPFWidth            = wm_User + 344;
	he_SetAllPFWidthExt         = wm_User + 345;

    { ab Version 1.15 }

	he_SetTextSelectable        = wm_User + 352;
	he_IsTextSelectable         = wm_User + 353;

    { ab Version 1.20 }

    he_SetLineeditable          = wm_User + 313;
	he_IsLineEditable           = wm_User + 314;
	he_SetIgnoreEditable        = wm_User + 362;
	he_IsIgnoreEditable         = wm_User + 363;
	he_SetSelectionEditable     = wm_User + 364;
	he_SetAbortDlg              = wm_User + 365;
	he_SetPageCounter           = wm_User + 366;
	he_GetTab                   = wm_User + 367;

    { ab Version 1.25 }

    he_SetClearDelete           = wm_User + 383;
    he_IsClearDelete            = wm_User + 384;

    { ab Version 1.26 }

    he_SetPercentThumb          = wm_User + 386;
    he_IsPercentThumb           = wm_User + 387;

    { ab Version 1.27 }

    he_GetFunctionPFTyp         = wm_User + 388;
    he_GetFunctionTableCount    = wm_User + 389;

	{ ab Version 2.00 }

	he_InsertBitmap 			= wm_User + 110;
	he_LoadBitmap				= wm_User + 368;
	he_LoadPCX					= wm_User + 369;
	he_LoadGIF					= wm_User + 370;
	he_LoadTIFF 				= wm_User + 371;
	he_LoadTARGA				= wm_User + 372;
	he_SetPictureFlags			= wm_User + 373;
	he_GetPictureFlags			= wm_User + 374;
	he_LoadWMF					= wm_User + 390;
	he_ShowHeadFoot 			= wm_User + 391;
	he_IsHeadFootVisible		= wm_User + 392;
	he_SetContext				= wm_User + 393;
	he_GetContext				= wm_User + 394;
	he_SetPictureFrame			= wm_User + 395;
	he_IsPictureFrame			= wm_User + 396;
	he_GetScrollPos 			= wm_User + 397;
	he_GetHeadFootHwnd			= wm_User + 398;
	he_SetPictureDim			= wm_User + 399;
	he_SetPictureOffset 		= wm_User + 400;
	he_GetPictureDim			= wm_User + 401;
	he_GetPictureOffset 		= wm_User + 402;
	he_EnableScreenFonts		= wm_User + 403;
	he_IsScreenFontsEnabled		= wm_User + 404;
	he_IsScreenFont		 		= wm_User + 405;
	he_GetScreenColorLogFont	= wm_User + 406;

  	{ ab Version 2.03 }

	he_GetPrinterLineWidth		= wm_User + 427;

    { ab Version 3.00 }

    he_Preview                  = wm_User + 160;
	he_IsPreview                = wm_User + 304;
	he_Undo                     = wm_User + 328;
	he_CanUndo                	= wm_User + 329;
	he_QueryUndoType            = wm_User + 330;
	he_SetInstancePrinter       = wm_User + 407;
	he_GetInstancePrinter       = wm_User + 409;
	he_InsertTable              = wm_User + 420;
	he_GetUndoDepth             = wm_User + 424;
	he_SetUndoDepth             = wm_User + 425;
	he_ClearUndoList            = wm_User + 426;
	he_CopyRTF                  = wm_User + 429;
	he_PasteRTF                 = wm_User + 430;
	he_IsTableActive            = wm_User + 432;
	he_CloseActiveTable         = wm_User + 433;
	he_InsertTableRow           = wm_User + 434;
	he_DeleteTableRow           = wm_User + 435;
	he_AdjustTable              = wm_User + 436;
	he_TableActivate            = wm_User + 437;

type
	PStatusLine = ^TStatusLine;
	TStatusLine = record
		rect: TRect;
		bHidden: Bool;
		hfont: HFont;
	end;

type
	PColorLogFont = ^TColorLogFont;
	TColorLogFont = record
		wHeight: Word;
		lf: TLogFont;
		rgb: TColorRef;
	end;

type
	PExtTabData = ^TExtTabData;
	TExtTabData = record
		lPrinterOffset: LongInt;
		lUnitOffset: LongInt;
		byTabTyp: Byte;
		pad: Byte;
	end;

type
	PTab = ^TTab;
	TTab = record
		byNumber: Byte;
		pad: Byte;
	end;

type
	PTextFragment = ^TTextFragment;
	TTextFragment = record
		byTyp: Byte;
		byColor: Byte;
		wStyleTyp: Word;
		iYOffset: Integer;
		lHeight: LongInt;
		hdc: HDC;
		rc: TRect;
		x: LongInt;
		y: LongInt;
		lWidth: LongInt;
		lInternalWidth: LongInt;
		lInternalHeight: LongInt;
		xInternalOffset: LongInt;
		yInternalOffset: LongInt;
		lMFWidth: LongInt;
		lMFHeight: LongInt;
		xMFOffset: LongInt;
		yMFOffset: LongInt;
		hfont: HFont;
		piDeltaX: PInteger;
		wDataLen: Word;
	end;

type
	PPrintDocParam = ^TPrintDocParam;
	TPrintDocParam = record
		hdc: HDC;
		rc: TRect;
		hwndHead: HWnd;
		hwndFoot: HWnd;
		bDummy: Bool;
		wStartPage: Word;
		wEndPage: Word;
        wPageCounter: Word;
        pDocTitle: PStr;
	end;

type
	PGetDocInfo = ^TGetDocInfo;
	TGetDocInfo = record
		hInfo: array [0..8] of TGlobalHandle;
		lDocVersion: LongInt;
		lProgVersion: LongInt;
	end;

type
	PSetDocInfo = ^TSetDocInfo;
	TSetDocInfo = record
		hInfo: array [0..5] of PStr;
	end;

type
	PTypFlags = ^TTypFlags;
    TTypFlags = record
    	byTyp: Byte;
        byFlags: Byte;
    end;

type
	PInsertFunctionPFParam = ^TInsertFunctionPFParam;
    TInsertFunctionPFParam = record
    	wTyp: Word;
        wFlags: Word;
        pData: PStr;
    end;

type
	PAbortDlgParam = ^TAbortDlgParam;
    TAbortDlgParam = record
    	hdc: HDC;
    	hwndAbort: HWnd;
    	hwndTop: HWnd;
    	hwndPage: HWnd;
        wPageCounter: Word;
        pPage: PStr;
        pDocTitle: PStr;
		pfnAbortProc: TFarProc;
    end;

type
	PMoveTabParam = ^TMoveTabParam;
	TMoveTabParam = record
		lUnitOffset: LongInt;
		lPrinterOffset: LongInt;
    end;

type
	PMoveMarginParam = ^TMoveMarginParam;
	TMoveMarginParam = record
		lUnitOffset: LongInt;
		lPrinterOffset: LongInt;
		lIndentOffset: LongInt;
		byTyp: Byte;
		pad: Byte;
    end;

	{ Macros }

	function GetYPos (plCursor: PLongInt) : LongInt;
	function GetXPos (plCursor: PLongInt) : Word;

    { Export }

	procedure HighEditInit (HInst: Word); far;
	function HighEditVersion : LongInt; far;

{ HETOOLS.DLL: Statusline }

const
	ws_DefStatus		= ws_Child + ws_Visible;

	class_Status		= 'HEToolsStatus';

    sl_MinWidth			= wm_User + 1;
    sl_SetItem 	 		= wm_User + 2;
    sl_SetItemText		= wm_User + 3;
    sl_DisplayMenuText 	= wm_User + 4;
    sl_RemoveMenuText	= wm_User + 5;
    sl_GetHeight		= wm_User + 6;
	sl_DisplayText		= wm_User + 7;

    sln_NewHeight		= 1;

{ HETOOLS.DLL: Ruler }

const
    rs_UnitsIN 	= $0010;
    rs_UnitsCM 	= $0020;
    rs_UnitsPT 	= $0040;
    rs_Horz 	= $0080;
    rs_Vert 	= $0100;

	ws_DefRuler		= ws_Child + ws_Visible + rs_UnitsCM + rs_Horz;

	class_Ruler		= 'HEToolsRuler';

    rl_HScroll		= wm_User + 1;
    rl_SetOffset	= wm_User + 2;
    rl_VScroll		= wm_User + 3;
    rl_SetUnit		= wm_User + 4;
    rl_SetRepeat	= wm_User + 5;
    rl_SetMirror	= wm_User + 6;

	rn_LButtonDblClk = 1;
	rn_RButtonDblClk = 2;

{ HETOOLS.DLL: Tabulator }

const
	ws_DefTab 			= ws_Child + ws_Visible;

	class_Tab 			= 'HEToolsTab';

	tm_DelIndent		= wm_User + 1;
    tm_DelLeftMargin	= wm_User + 2;
    tm_DelRightMargin	= wm_User + 3;
    tm_GetLeftMargin	= wm_User + 4;
    tm_GetRightMargin	= wm_User + 5;
    tm_GetPos			= wm_User + 6;
	tm_SetIndent		= wm_User + 9;
    tm_SetLeftMargin	= wm_User + 10;
    tm_SetRightMargin	= wm_User + 11;
    tm_SetTab			= wm_User + 12;
    tm_SetTabList		= wm_User + 13;
    tm_SetOffset		= wm_User + 14;
    tm_SetPrinterOffset	= wm_User + 15;
    tm_HScroll			= wm_User + 16;
    tm_GetScrollPos		= wm_User + 17;
    tm_SetUnit			= wm_User + 18;
	tm_GetDisplayPos	= wm_User + 19;
	tm_GetTyp			= wm_User + 20;
	tm_SetTyp			= wm_User + 21;
	tm_GetTabWidth		= wm_User + 22;
	tm_SetTabWidth		= wm_User + 23;
	tm_GetIndent		= wm_User + 24;

    tn_Int_Error		= $00;
    tn_Int_Insert		= $01;
    tn_Int_Update		= $02;
    tn_Int_Delete		= $03;
    tn_Int_MouseMove	= $04;
    tn_Int_LeftScroll	= $05;
    tn_Int_RightScroll	= $06;
    tn_Int_ScrollPos	= $07;

    tn_InsertTab		= $0100;
    tn_InsertLM			= $0106;
    tn_InsertRM			= $0107;
    tn_InsertIndent		= $0109;
    tn_UpdateTab		= $0200;
    tn_UpdateLM			= $0206;
    tn_UpdateRM			= $0207;
    tn_UpdateIndent		= $0209;
    tn_DeleteTab		= $0300;
    tn_MouseMoveTab		= $0400;
    tn_MouseMoveLM		= $0406;
    tn_MouseMoveRM		= $0407;
    tn_MouseMoveIndent	= $0409;
    tn_LeftScrollLM		= $0506;
    tn_LeftScrollRM		= $0507;
    tn_LeftScrollIndent = $0509;
    tn_RightScrollLM	= $0606;
    tn_RightScrollRM	= $0607;
    tn_RightScrollIndent = $0609;
	tn_ScrollPos		= $0700;

	tab_Offset_Error	= $80000000;
	tab_ScrollAmount	= 2;

	{ Macros }

	function Tab_GetUnitPos (plCursor: PLongInt) : LongInt;
	function Tab_GetPrinterPos (plCursor: PLongInt) : LongInt;

    { Export }

	procedure HEToolsInit (HInst: Word); far;

{ HEDLG.DLL }

const
	FileText_Max = 4;	{ Text Formate }
	FilePic_Max  = 6;	{ Bild Formate }

	FileFormat_HighEdit = 0;
	FileFormat_ANSI 	= 1;
	FileFormat_OEM		= 2;
	FileFormat_RTF		= 3;

	FileFormat_Bitmap	= 0;
	FileFormat_PCX		= 1;
	FileFormat_GIF		= 2;
	FileFormat_TIFF 	= 3;
	FileFormat_TARGA	= 4;
	FileFormat_WMF		= 5;

type
	PColorBoxParam = ^TColorBoxParam;
	TColorBoxParam = record
		cr: TColorRef;
	end;

type
	PBackColorBoxParam = ^TBackColorBoxParam;
	TBackColorBoxParam = record
		crBk: TColorRef;
		crPF: TColorRef;
	end;

type
	PFormatDocBoxParam = ^TFormatDocBoxParam;
	TFormatDocBoxParam = record
		hwndEdit: HWnd;
		hfontThin: HFont;
		wWidth: Word;
		wHeight: Word;
		wTop: Word;
		wLeft: Word;
		wBottom: Word;
		wRight: Word;
		wTab: Word;
	end;

type
	PFontBoxParam = ^TFontBoxParam;
	TFontBoxParam = record
		clf: TColorLogFont;
		hEnumFont: TLocalHandle;
		hfontThin: HFont;
        hbmFont: array[0..5] of HBitmap;
        bIsScreenFont: Bool;
        bScreenFontsEnabled: Bool;
	end;

type
	PFileBoxParam = ^TFileBoxParam;
	TFileBoxParam = record
		szPathName: array [0..127] of Char;
		szFileName: array [0..13] of Char;
		szTextExt: array [0..(FileText_Max - 1)] of array [0..5] of Char;
		szPicExt: array [0..(FilePic_Max - 1)] of array [0..5] of Char;
		wFileType: Word;
		bSaveBox: Bool;
		bPictureBox: Bool;
		hfontThin: HFont;
	end;

type
	PSearchBoxParam = ^TSearchBoxParam;
	TSearchBoxParam = record
		szSearchText: array [0..127] of Char;
		szReplaceText: array [0..127] of Char;
		wSearchFlags: Word;
		bReplaceBox: Bool;
		hwndEdit: HWnd;
		hfontThin: HFont;
		wInternalSearchFlags: Word;
	end;

type
	PDocInfoBoxParam = ^TDocInfoBoxParam;
	TDocInfoBoxParam = record
		hwndEdit: HWnd;
		hfontThin: HFont;
	end;

type
	PParagraphBoxParam = ^TParagraphBoxParam;
	TParagraphBoxParam = record
		hwndEdit: HWnd;
		hfontThin: HFont;
		hTab: THandle;
		hbmTab: array [0..3] of HBitmap;
	end;

type
	PPrintBoxParam = ^TPrintBoxParam;
	TPrintBoxParam = record
		hwndEdit: HWnd;
		hfontThin: HFont;
   		hfontThinSetup: HFont;
		wFlags: Word;
		pdp: TPrintDocParam;
        hDevNames: THandle;
        hDevMode: THandle;
	end;

	{ Export }

	procedure HEDialogInit (hInst: Word); far;

	function ColorDialogBox 		(hwnd: HWnd; pColorBoxParam : PColorBoxParam) : Integer; far;
    function FormatDocDialogBox	  	(hwnd: HWnd; pDokumentBoxParam : PFormatDocBoxParam) : Bool; far;
    function SearchDialogBox 	  	(hwnd: HWnd; pSearchBoxParam : PSearchBoxParam) : Bool; far;
	function ReplaceDialogBox	  	(hwnd: HWnd; pSearchBoxParam : PSearchBoxParam) : Word; far;
	function QueryReplaceDialogBox 	(hwnd: HWnd; pSearchBoxParam : PSearchBoxParam) : Word; far;
    function FileAppendDialogBox   	(hwnd: HWnd; pFileBoxParam : PFileBoxParam) : Bool; far;
    function FileOpenDialogBox	  	(hwnd: HWnd; pFileBoxParam : PFileBoxParam) : Bool; far;
    function FileSaveDialogBox	  	(hwnd: HWnd; pFileBoxParam : PFileBoxParam) : Bool; far;
    function FileDeleteDialogBox   	(hwnd: HWnd; pFileBoxParam : PFileBoxParam) : Bool; far;
    function PictureOpenDialogBox  	(hwnd: HWnd; pFileBoxParam : PFileBoxParam) : Bool; far;
    function FontDialogBox		  	(hwnd: HWnd; pFontBoxParam : PFontBoxParam) : Bool; far;
    function DocInfoDialogBox	  	(hwnd: HWnd; pDocInfoBoxParam : PDocInfoBoxParam) : Bool; far;
	function BackColorDialogBox 	(hwnd: HWnd; pBackColorBoxParam : PBackColorBoxParam) : Bool; far;
	function ParagraphDialogBox 	(hwnd: HWnd; pParagraphBoxParam : PParagraphBoxParam) : Bool; far;
	function PrintDialogBox 		(hwnd: HWnd; pPrintBoxParam : PPrintBoxParam) : Bool; far;
	function PrintSetupDialogBox 	(hwnd: HWnd; pPrintBoxParam : PPrintBoxParam) : Bool; far;

{ HEICON.DLL }

const
	ws_DefIconBar		= ws_Child + ws_Visible + ws_ClipSiblings;

	class_IconBar		= 'HEIconBar';

	ibn_Style			= 1;
	ibn_Align			= 2;
	ibn_Spacing 		= 3;
	ibn_Color			= 4;
	ibn_Display 		= 5;
	ibn_FontName		= 6;
	ibn_FontSize		= 7;
	ibn_DblClk			= 8;
	ibn_Tab 			= 9;

	ibm_SetStyle		= wm_User + 1;
	ibm_GetStyle		= wm_User + 2;
	ibm_SetAlign		= wm_User + 3;
	ibm_GetAlign		= wm_User + 4;
	ibm_SetSpacing		= wm_User + 5;
	ibm_GetSpacing		= wm_User + 6;
	ibm_GetColor		= wm_User + 7;
	ibm_GetDisplay		= wm_User + 8;
	ibm_SetDisplay		= wm_User + 9;
	ibm_GetColorLogFont = wm_User + 12;
	ibm_SetColorLogFont = wm_User + 13;
	ibm_SetFontSize 	= wm_User + 14;
    ibm_HideDropDown	= wm_User + 15;
	ibm_GetTab			= wm_User + 16;
	ibm_SetTab			= wm_User + 17;
	ibm_EnableScreenFonts	= wm_User + 18;
	ibm_IsScreenFont		= wm_User + 19;

    { Export }

	procedure HEIconBarInit (HInst: Word); far;

implementation

function GetYPos (plCursor: PLongInt) : LongInt;
begin
	GetYPos := PLongInt (LongInt (plCursor) + SizeOf (LongInt))^
end;

function GetXPos (plCursor: PLongInt) : Word;
begin
    GetXPos := LoWord (plCursor^)
end;

function Tab_GetPrinterPos (plCursor: PLongInt) : LongInt;
begin
	Tab_GetPrinterPos := PLongInt (LongInt (plCursor) + SizeOf (LongInt))^
end;

function Tab_GetUnitPos (plCursor: PLongInt) : LongInt;
begin
	Tab_GetUnitPos := plCursor^
end;

procedure HighEditInit;		external 'HIGHEDIT' index 8;
function  HighEditVersion; 	external 'HIGHEDIT' index 9;

procedure HEToolsInit;		external 'HETOOLS' index 3;
procedure HEIconBarInit;	external 'HEICON' index 2;
procedure HEDialogInit;		external 'HEDLG' index 2;

function ColorDialogBox; 		external 'HEDLG' index 10;
function FormatDocDialogBox;  	external 'HEDLG' index 19;
function SearchDialogBox; 	  	external 'HEDLG' index 11;
function ReplaceDialogBox;	  	external 'HEDLG' index 12;
function QueryReplaceDialogBox;	external 'HEDLG' index 13;
function FileAppendDialogBox;  	external 'HEDLG' index 14;
function FileOpenDialogBox;	  	external 'HEDLG' index 15;
function FileSaveDialogBox;	  	external 'HEDLG' index 16;
function FileDeleteDialogBox;  	external 'HEDLG' index 21;
function PictureOpenDialogBox; 	external 'HEDLG' index 20;
function FontDialogBox;		  	external 'HEDLG' index 18;
function DocInfoDialogBox;	  	external 'HEDLG' index 23;
function BackColorDialogBox; 	external 'HEDLG' index 24;
function ParagraphDialogBox;	external 'HEDLG' index 25;
function PrintDialogBox;		external 'HEDLG' index 26;
function PrintSetupDialogBox;	external 'HEDLG' index 27;

end.
